﻿Option Strict On
Imports Microsoft.PointOfService
Imports System.Globalization
Public Class Form1
    Inherits System.Windows.Forms.Form
    Private m_Printer As Microsoft.PointOfService.PosPrinter = Nothing
    Private CtInfo As New CultureInfo("de-De")
    ' Private CtInfo As New CultureInfo("de-De")
    'ESC command
    Private ESC As String = Chr(&H1B)

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        '<<<step1>>>--Start
        'Use a Logical Device Name which has been set on the SetupPOS.
        Dim strLogicalName As String
        Dim deviceInfo As DeviceInfo
        Dim m_posExplorer As PosExplorer
        Dim flag_op As Boolean = True
        strLogicalName = "PosPrinter"
        'Create PosExplorer
        m_posExplorer = New PosExplorer
        m_Printer = Nothing
        If flag_op = True Then
            Timer1.Enabled = True
            Timer1.Interval = 1500
        End If
        Try
            deviceInfo = m_posExplorer.GetDevice(DeviceType.PosPrinter, strLogicalName)
            m_Printer = CType(m_posExplorer.CreateInstance(deviceInfo), PosPrinter)

        Catch ex As Exception
            ChangeButtonStatus()
            Return
        End Try
        Try
            'Open the device
            m_Printer.Open()
            'Get the exclusive control right for the opened device.
            'Then the device is disable from other application.
            m_Printer.Claim(1000)
            'Enable the device.
            m_Printer.DeviceEnabled = True
            Label1.Text = m_Printer.DeviceName
            Label2.Text = m_Printer.CoverOpen.ToString
        Catch ex As PosControlException
            ChangeButtonStatus()
        End Try
        '<<<step1>>>--End
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        '<<<step2>>>--Start
        'Initialization
        'Dim ESC As String * 1
        Dim dateTime As DateTime = New DateTime
        Dim dateFormat As DateTimeFormatInfo = New DateTimeFormatInfo
        Dim strDate As String

        'Get current date
        dateTime = System.DateTime.Now()
        dateFormat.MonthDayPattern = "MMMM"
        strDate = dateTime.ToString("MMMM,dd,yyyy,  HH:mm", dateFormat)
        Try
            'Print address
            m_Printer.PrintNormal(PrinterStation.Receipt, ESC + "|N" _
            + "123xxstreet,xxxcity,xxxxstate" + vbCrLf)
            'Print phone number
            m_Printer.PrintNormal(PrinterStation.Receipt, ESC + "|rA" _
            + "TEL 9999-99-9999   C#2" + vbCrLf)
            'Print date
            'ESC|cA = Centaring char
            m_Printer.PrintNormal(PrinterStation.Receipt, ESC + "|cA" + strDate + vbCrLf + vbCrLf)
            'Print buying goods
            m_Printer.PrintNormal(PrinterStation.Receipt, "apples                  $20.00" + vbCrLf)
            m_Printer.PrintNormal(PrinterStation.Receipt, "grapes                  $30.00" + vbCrLf)
            m_Printer.PrintNormal(PrinterStation.Receipt, "bananas                 $40.00" + vbCrLf)
            m_Printer.PrintNormal(PrinterStation.Receipt, "lemons                  $50.00" + vbCrLf)
            m_Printer.PrintNormal(PrinterStation.Receipt, "oranges                 $60.00" + vbCrLf + vbCrLf)
            '//Print the total cost
            '//ESC|bC = Bold
            '//ESC|uC = Underline
            '//ESC|2C = Wide charcter
            m_Printer.PrintNormal(PrinterStation.Receipt, ESC + "|bC" _
            + "Tax excluded.          $200.00" + ESC + "|N" + vbCrLf)
            m_Printer.PrintNormal(PrinterStation.Receipt, ESC + "|uC" _
            + "Tax  5.0%               $10.00" + ESC + "|N" + vbCrLf)
            m_Printer.PrintNormal(PrinterStation.Receipt, ESC + "|bC" + ESC + "|2C" _
            + "Total   $210.00" + ESC + "|N" + vbCrLf)

            m_Printer.PrintNormal(PrinterStation.Receipt, "Customer's payment     $250.00" + vbCrLf)
            m_Printer.PrintNormal(PrinterStation.Receipt, "Change                  $40.00" + vbCrLf + vbCrLf)
            m_Printer.PrintNormal(PrinterStation.Receipt, ESC + "|cA" + ESC + "|2C" + "Thaks for shoping")
            'Feed the receipt to the cutter position automatically, and cut.
            'ESC|#fP = Line Feed and Paper cut    
            Dim TestCutting As String = ESC & "|100fP"
            m_Printer.PrintNormal(PrinterStation.Receipt, TestCutting)
        Catch ex As PosControlException
        End Try
        '//<<<step2>>>--End
    End Sub
End Class
